/*
 * $Id: blankerprefs.c,v 1.7 2007/09/09 17:15:05 piru Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <aros/asmcall.h>
#include <string.h>

#define DEBUG 0
#include <aros/debug.h>

AROS_UFH1(LONG, BlankerPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct BlankerPrefs iprefs;

	D(bug("IPrefs: BlankerPrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		SetIPrefs(&iprefs, sizeof(iprefs), IP_BLANKER);
	}

	return 0;

	AROS_LIBFUNC_EXIT
}


static
const UBYTE options[]=
	"Name/K,"
	"Type/N/K,"
	"Width/N/K,"
	"Height/N/K,"
	"Monitor/N/K,"
	"BlankTime/N/K,"
	"DPMSSuspendTime/N/K,"
	"DPMSStandbyTime/N/K,"
	"DPMSOnTime/N/K,"
	"EventFlags/N/K,"
	"OffFlags/N/K,"
	"Blanker/K,"
	"Tag/N/K,"
	"Value/N/K,"
	"String/K,"
	"/F";


struct Args
{
	STRPTR	Name;
	ULONG	*Type;
	ULONG	*Width;
	ULONG	*Height;
	ULONG	*Monitor;
	ULONG	*BlankTime;
	ULONG	*DPMSSuspendTime;
	ULONG	*DPMSStandbyTime;
	ULONG	*DPMSOnTime;
	ULONG	*EventFlags;
	ULONG	*OffFlags;
	STRPTR	Blanker;
	ULONG	*Tag;
	ULONG	*Value;
	STRPTR	String;
	STRPTR	FutureArgs;
};

#define BLANKER_FILENAME2_USE  "env:sys/blanker.conf"
/*
 * New Blanker prefs
 */
void LoadBlankerPrefs(char *filename)
{
	BPTR		MyFile;
	struct BlankerPrefs Blanker_Prefs;

	strcpy(Blanker_Prefs.BlankerName,"butterflies.btd");
	Blanker_Prefs.BlankerType = 0;
	Blanker_Prefs.BlankerWidth = 0;
	Blanker_Prefs.BlankerHeight = 0;
	Blanker_Prefs.BlankerMonitor = 0;
	Blanker_Prefs.BlankTime = 6000;
	Blanker_Prefs.DPMSSuspendTime = 0;
	Blanker_Prefs.DPMSStandbyTime = 0;
	Blanker_Prefs.DPMSOnTime = 18000;
	Blanker_Prefs.EventFlags = 0xFFFFFFFF;
	Blanker_Prefs.OffFlags = 0xFFFFFFFF;

	D(bug("%s: New Blanker <%s>\n",__func__,filename));
	if ((MyFile = Open(filename, MODE_OLDFILE)))
	{
		char BlankerName[256];
		BPTR		OldFile;
		struct RDArgs rda;
		struct RDArgs *rda1;

		D(bug("%s: newformat\n",__func__));

		BlankerName[0] = '\0';

		memset(&rda,0,sizeof(struct RDArgs));

		OldFile = Input();
		SelectInput(MyFile);
		rda.RDA_Flags = RDAF_NOPROMPT | RDAF_STDIN;

		for (;;)
		{
			struct Args		args;

			memset(&args,0,sizeof(args));

		        if ((rda1 = ReadArgs(options, (LONG *)&args, &rda)))
				{
				if (args.Name)
				{
					stccpy(Blanker_Prefs.BlankerName,args.Name,sizeof(Blanker_Prefs.BlankerName));
					Blanker_Prefs.BlankerType = args.Type ? *args.Type : 0;
					Blanker_Prefs.BlankerWidth = args.Width ? *args.Width : 0;
					Blanker_Prefs.BlankerHeight = args.Height ? *args.Height : 0;
					Blanker_Prefs.BlankerMonitor = args.Monitor ? *args.Monitor : 0;
					Blanker_Prefs.BlankTime = args.BlankTime ? *args.BlankTime : 6000;
					Blanker_Prefs.DPMSSuspendTime = args.DPMSSuspendTime ? *args.DPMSSuspendTime : 0;
					Blanker_Prefs.DPMSStandbyTime = args.DPMSStandbyTime ? *args.DPMSStandbyTime : 0;
					Blanker_Prefs.DPMSOnTime = args.DPMSOnTime ? *args.DPMSOnTime : 18000;
					Blanker_Prefs.EventFlags = args.EventFlags ? *args.EventFlags : 0xFFFFFFFF;
					Blanker_Prefs.OffFlags = args.OffFlags ? *args.OffFlags : 0xFFFFFFFF;

					SetIPrefs(&Blanker_Prefs, sizeof(Blanker_Prefs), IP_BLANKER);
				}
				#if 0
				#warning "According to jacek this is part of Intuition"
				else
				if (args.Blanker)
				{
					stccpy(BlankerName,args.Blanker,sizeof(BlankerName));
					D(bug("%s: Blanker <%s>\n",__func__,BlankerName));
				}
				else
				if ((args.Tag && args.Value))
				{
					D(bug("%s: Tag 0x%lx Value 0x%lx\n",__func__,*args.Tag,*args.Value));
					//DoMethod(data->WI_Settings,MM_SettingsWindow_SetEntry,*args.Tag,*args.Value);
				}
				else
				if ((args.Tag && args.String))
				{
					D(bug("%s: Tag 0x%lx String <%s>\n",__func__,*args.Tag,args.String));
					//DoMethod(data->WI_Settings,MM_SettingsWindow_SetEntry,*args.Tag,args.String);
				}
				#endif
				else
				{
					D(bug("%s: no tag,value\n",__func__));
					break;
				}
				FreeArgs(rda1);
			}
			else
			{
				D(bug("%s: End IoErr %ld\n",__func__,IoErr()));
				break;
			}
		}
		SelectInput(OldFile);
		Close(MyFile);

	}
}
